#ifndef CODE_QT_H
#define CODE_QT_H

#include "UmlauteWeb_global.hpp"
#include <QString>

namespace Umlaute_Web
{
		class UMLAUTEWEB_EXPORT Qt
        {
			private:
				Qt();
				~Qt();

			public:
				/**
				 * @brief change web-escapes to special characters for non-browser-applications
				 *
				 * @param str Input String
				 */
				static void decode(QString &str);

				/**
				 * @brief  change special characters to web-escapes
				 *
				 * @param str Input String
				 */
				static void encode(QString &str);

				/**
				 * @brief remove all occureence of "--" in \p str
				 * @param str Input String
				 */
				static void removeSqlComments(QString &str);
        };        
} // namespace Umlaute_Web


#endif
