#include "Std.hpp"
#include <cstring>

Umlaute_Web::Std::Std() { }

Umlaute_Web::Std::~Std() { }

std::size_t Umlaute_Web::Std::replaceAll(std::string& inout, const char *what, const char *with)
{
    std::size_t count{};
	for (
		 std::string::size_type pos{};
		 inout.npos != (pos = inout.find(what, pos, std::strlen(what)));
		 pos += std::strlen(with), ++count
		)
	{
		inout.replace(pos, std::strlen(what), with, std::strlen(with));
    }
    return count;
}

void Umlaute_Web::Std::decode(std::string &str)
{
	replaceAll(str, "&Auml;", "Ä");
	replaceAll(str, "&amp;", "&");
	replaceAll(str, "&Uuml;", "Ü");
	replaceAll(str, "&Ouml;", "Ö");
	replaceAll(str, "&ouml;", "ö");
	replaceAll(str, "&auml;", "ä");
	replaceAll(str, "&aring;", "å");
	replaceAll(str, "&uuml;", "ü");
	replaceAll(str, "&ccedil;", "ç");
	replaceAll(str, "&egrave;", "è");
	replaceAll(str, "&#39;", "'");
	replaceAll(str, "&Ccedil;", "Ç");
	replaceAll(str, "&agrave;", "à");
	replaceAll(str, "&szlig;", "ß");
	replaceAll(str, "&percnt;", "%");
}

void Umlaute_Web::Std::encode(std::string &str)
{
	replaceAll(str, "&", "&amp;");
	replaceAll(str, "Ä", "&Auml;");
	replaceAll(str, "Ö", "&Ouml;");
	replaceAll(str, "Ü", "&Uuml;");
	replaceAll(str, "ä", "&auml;");
	replaceAll(str, "ö", "&ouml;");
	replaceAll(str, "ü", "&uuml;");
	replaceAll(str, "å", "&aring;");
	replaceAll(str, "è", "&egrave;");
	replaceAll(str, "ç", "&ccedil;");
	replaceAll(str, "Ç", "&Ccedil;");
	replaceAll(str, "'", "&#39;");
	replaceAll(str, "ß", "&szlig;");
	replaceAll(str, "à", "&agrave;");
	replaceAll(str, "%", "&percnt;");
}

void Umlaute_Web::Std::removeSqlComments(std::string &str)
{
	while (str.find("--") != std::string::npos)
	{
		replaceAll(str, "--", "-");
	}
}
